/*****************************************************************
;*         Sample SFR Header File for TLCS-870/C1 Series         *
;*               Memory Style: Within 64K byte                   *
;*---------------------------------------------------------------*
;*  (C)Copyright TOSHIBA CORPORATION 2008  All rights reserved   *
;*****************************************************************/
//version:20160801
//****************************************************************/
#ifdef IO_MEM
/* This definition is for I/O variable and extern definition */
/* So please do not use the name "IO_MEM".*/
#define EXTERN
#else
#define EXTERN extern
#endif
//****************************************************************/
//****************************************************************
typedef struct {
	const unsigned char b7:1;
	const unsigned char b6:1;
	const unsigned char b5:1;
	const unsigned char b4:1;
	const unsigned char b3:1;
	unsigned char b2:1;
	unsigned char b1:1;
	unsigned char b0:1;
} BYTE_FIELD_FSCTRL;
typedef union {
	const unsigned char   byte;
	BYTE_FIELD_FSCTRL      bit;
} TYPE_BYTE_FSCTRL;
//****************************************************************/
typedef struct {
	unsigned char b7:1;
	unsigned char b6:1;
	unsigned char b5:1;
	unsigned char b4:1;
	unsigned char b3:1;
	unsigned char b2:1;
	unsigned char b1:1;
	unsigned char b0:1;
} BYTE_FIELD;
/*=======  BYTE IO ========*/
typedef union {
	unsigned char   byte;
	BYTE_FIELD      bit;
} TYPE_BYTE;

typedef struct {
	unsigned int b15:1;
	unsigned int b14:1;
	unsigned int b13:1;
	unsigned int b12:1;
	unsigned int b11:1;
	unsigned int b10:1;
	unsigned int b9:1;
	unsigned int b8:1;
	unsigned int b7:1;
	unsigned int b6:1;
	unsigned int b5:1;
	unsigned int b4:1;
	unsigned int b3:1;
	unsigned int b2:1;
	unsigned int b1:1;
	unsigned int b0:1;
} WORD_FIELD;
/*======= WORD IO ========*/
typedef union {
 	unsigned int    word;
 	unsigned char   byte[2];
 	WORD_FIELD      bit;
} TYPE_WORD;
typedef union {
 	unsigned int    word;
 	unsigned char   byte[2];
	TYPE_BYTE       TBYTE[2];
 	WORD_FIELD      bit;
} TYPE_WORD_EX;
/***[SFR1]******************************************************/
EXTERN TYPE_BYTE        __io(0x0000)    P0DR;            /* Port P0 output latch */
EXTERN TYPE_BYTE        __io(0x0001)    P1DR;            /* Port P1 output latch */
EXTERN TYPE_BYTE        __io(0x0002)    P2DR;            /* Port P2 output latch */ 
/*---   (0x0003)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0004)    P4DR;            /* Port P4 output latch */
EXTERN TYPE_BYTE        __io(0x0005)    P5DR;            /* Port P5 output latch */
/*---   (0x0006)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0007)    P7DR;            /* Port P7 output latch */
EXTERN TYPE_BYTE        __io(0x0008)    P8DR;            /* Port P8 output latch */
EXTERN TYPE_BYTE        __io(0x0009)    P9DR;            /* Port P9 output latch */
//EXTERN TYPE_BYTE        __io(0x000B)    PBDR;            /* Port PB output latch */	
EXTERN TYPE_BYTE        __io(0x000D)    P0PRD;           /* Port P0 input data */
EXTERN TYPE_BYTE        __io(0x000E)    P1PRD;           /* Port P1 input data */
EXTERN TYPE_BYTE        __io(0x000F)    P2PRD;           /* Port P2 input data */
/*---   (0x0010)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0011)    P4PRD;           /* Port P4 input data */
EXTERN TYPE_BYTE        __io(0x0012)    P5PRD;           /* Port P5 input data */
/*---   (0x0013)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0014)    P7PRD;           /* Port P7 input data */
EXTERN TYPE_BYTE        __io(0x0015)    P8PRD;           /* Port P8 input data */
EXTERN TYPE_BYTE        __io(0x0016)    P9PRD;           /* Port P9 input data */
/*---   (0x0017)    Reserved   ---*/
//EXTERN TYPE_BYTE        __io(0x0018)    PBPRD;           /* Port PB input data */
EXTERN TYPE_BYTE        __io(0x001A)    UART0CR1;        /* UART0 control register 1 */
EXTERN TYPE_BYTE        __io(0x001B)    UART0CR2;        /* UART0 control register 2 */
EXTERN TYPE_BYTE    __io(0x001C)    UART0DR;         /* UART0 baud rate register */
EXTERN TYPE_BYTE        __io(0x001D)    UART0SR;         /* UART0 status register */
EXTERN TYPE_BYTE    __io(0x001E)    U0BF;
#define TD0BUF U0BF                                 
/* UART0 transmit data buffer */
#define RD0BUF U0BF                                 
/* UART0 receive data buffer */
EXTERN TYPE_BYTE        __io(0x001F)    SIO0CR;          /* Serial interface 0 control register */
EXTERN TYPE_BYTE        __io(0x0020)    SIO0SR;          /* Serial interface 0 status register */
EXTERN TYPE_BYTE    __io(0x0021)    SIO0BUF;         /* Serial interface 0 buffer register */
EXTERN TYPE_BYTE        __io(0x0022)    SBI0CR1;         /* Serial bus interface 0 control register 1 */
EXTERN TYPE_BYTE        __io(0x0023)    S0CS;
#define SBI0CR2 S0CS
                                /* Serial bus interface 0 control register 2 */
#define SBI0SR2 S0CS
                                /* Serial bus interface 0 status register 2 */
EXTERN TYPE_BYTE        __io(0x0024)    I2C0AR;          /* I2C bus address 0 register */
EXTERN TYPE_BYTE 		__io(0x0025)    SBI0DBR;         /* Serial bus interface 0 data buffer register */
EXTERN TYPE_BYTE        __io(0x0026)    T00REG;        
EXTERN TYPE_BYTE        __io(0x0027)    T01REG;        
EXTERN TYPE_BYTE        __io(0x0028)    T00PWM;        
EXTERN TYPE_BYTE        __io(0x0029)    T01PWM;        
EXTERN TYPE_BYTE        __io(0x002A)    T00MOD;          /* Timer counter 00 mode register */
EXTERN TYPE_BYTE        __io(0x002B)    T01MOD;          /* Timer counter 01 mode register */
EXTERN TYPE_BYTE        __io(0x002C)    T001CR;          /* Timer counter 001 control register */
//EXTERN TYPE_BYTE        __io(0x002D)    TA0DRAL;
//EXTERN TYPE_BYTE        __io(0x002E)    TA0DRAH;
//EXTERN TYPE_BYTE        __io(0x002F)    TA0DRBL;
//EXTERN TYPE_BYTE        __io(0x0030)    TA0DRBH;

EXTERN TYPE_WORD_EX        __io(0x002D)    TA0DRA;
//#define TA0DRA _TA0DRA.word
#define TA0DRAL TA0DRA.TBYTE[0]                           
/* Timer counter A0 register AL */
#define TA0DRAH TA0DRA.TBYTE[1]                          
 /* Timer counter A0 register AH */
EXTERN TYPE_WORD_EX        __io(0x002F)    TA0DRB;
//#define TA0DRB _TA0DRB.word
#define TA0DRBL TA0DRB.TBYTE[0]
                           /* Timer counter A0 register BL */
#define TA0DRBH TA0DRB.TBYTE[1] 
                           /* Timer counter A0 register BH */
EXTERN TYPE_BYTE        __io(0x0031)    TA0MOD;          /* Timer counter A0 mode register */
EXTERN TYPE_BYTE        __io(0x0032)    TA0CR;           /* Timer counter A0 control register */
EXTERN TYPE_BYTE        __io(0x0033)    TA0SR;           /* Timer counter A0 status register */
EXTERN TYPE_BYTE        __io(0x0034)    ADCCR1;          /* AD converter control register 1 */
EXTERN TYPE_BYTE        __io(0x0035)    ADCCR2;          /* AD converter control register 2 */
EXTERN TYPE_BYTE    	__io(0x0036)    ADCDRL;          /* AD converted value register (lower side) */
EXTERN TYPE_BYTE    	__io(0x0037)    ADCDRH;          /* AD converted value register (upper side) */
EXTERN TYPE_BYTE        __io(0x0038)    DVOCR;           /* Divider output control register */
EXTERN TYPE_BYTE        __io(0x0039)    TBTCR;           /* Time base timer control register */
EXTERN TYPE_BYTE        __io(0x003A)    EIRL;            /* Interrupt enable register (EIRL) */
EXTERN TYPE_BYTE        __io(0x003B)    EIRH;            /* Interrupt enable register (EIRH) */
EXTERN TYPE_BYTE        __io(0x003C)    EIRE;            /* Interrupt enable register (EIRE) */
EXTERN TYPE_BYTE        __io(0x003D)    EIRD;            /* Interrupt enable register (EIRD) */
/*---   (0x003E)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x003F)    PSW;             /* Program status word */

/***[SFR3]******************************************************/

EXTERN TYPE_BYTE        __io(0x0E40)    LCDBUF00;     
EXTERN TYPE_BYTE        __io(0x0E41)    LCDBUF01;     
EXTERN TYPE_BYTE        __io(0x0E42)    LCDBUF02;     
EXTERN TYPE_BYTE        __io(0x0E43)    LCDBUF03;     
EXTERN TYPE_BYTE        __io(0x0E44)    LCDBUF04;     
EXTERN TYPE_BYTE        __io(0x0E45)    LCDBUF05;     
EXTERN TYPE_BYTE        __io(0x0E46)    LCDBUF06;     
EXTERN TYPE_BYTE        __io(0x0E47)    LCDBUF07;  
EXTERN TYPE_BYTE        __io(0x0E48)    LCDBUF08;     
EXTERN TYPE_BYTE        __io(0x0E49)    LCDBUF09;     
EXTERN TYPE_BYTE        __io(0x0E4A)    LCDBUF10;     
EXTERN TYPE_BYTE        __io(0x0E4B)    LCDBUF11;       
EXTERN TYPE_BYTE        __io(0x0E4C)    LCDBUF12;
EXTERN TYPE_BYTE        __io(0x0E4D)    LCDBUF13;
EXTERN TYPE_BYTE        __io(0x0E4E)    LCDBUF14;
EXTERN TYPE_BYTE        __io(0x0E4F)    LCDBUF15;
EXTERN TYPE_BYTE        __io(0x0E50)    LCDBUF16;
EXTERN TYPE_BYTE        __io(0x0E51)    LCDBUF17;
EXTERN TYPE_BYTE        __io(0x0E52)    LCDBUF18;
EXTERN TYPE_BYTE        __io(0x0E53)    LCDBUF19;
EXTERN TYPE_BYTE        __io(0x0E54)    LCDBUF20;
EXTERN TYPE_BYTE        __io(0x0E55)    LCDBUF21;
EXTERN TYPE_BYTE        __io(0x0E56)    LCDBUF22;
EXTERN TYPE_BYTE        __io(0x0E57)    LCDBUF23;
EXTERN TYPE_BYTE        __io(0x0E58)    LCDBUF24;
EXTERN TYPE_BYTE        __io(0x0E59)    LCDBUF25;
EXTERN TYPE_BYTE        __io(0x0E5A)    LCDBUF26;
EXTERN TYPE_BYTE        __io(0x0E5B)    LCDBUF27;
/*---   (0x0E5C)    Reserved   ---*/
/*---   (0x0E5D)    Reserved   ---*/
/*---   (0x0E5E)    Reserved   ---*/
/*---   (0x0E5F)    Reserved   ---*/
/*---   (0x0E60)    Reserved   ---*/
/*---   (0x0E61)    Reserved   ---*/
/*---   (0x0E62)    Reserved   ---*/
/*---   (0x0E63)    Reserved   ---*/
/*---   (0x0E64)    Reserved   ---*/
/*---   (0x0E65)    Reserved   ---*/
/*---   (0x0E66)    Reserved   ---*/
/*---   (0x0E67)    Reserved   ---*/
/*---   (0x0E68)    Reserved   ---*/
/*---   (0x0E69)    Reserved   ---*/
/*---   (0x0E6A)    Reserved   ---*/
/*---   (0x0E6B)    Reserved   ---*/
/*---   (0x0E6C)    Reserved   ---*/
/*---   (0x0E6D)    Reserved   ---*/
/*---   (0x0E6E)    Reserved   ---*/
/*---   (0x0E6F)    Reserved   ---*/
/*---   (0x0E70)    Reserved   ---*/
/*---   (0x0E71)    Reserved   ---*/
/*---   (0x0E72)    Reserved   ---*/
/*---   (0x0E73)    Reserved   ---*/
/*---   (0x0E74)    Reserved   ---*/
/*---   (0x0E75)    Reserved   ---*/
/*---   (0x0E76)    Reserved   ---*/
/*---   (0x0E77)    Reserved   ---*/
/*---   (0x0E78)    Reserved   ---*/
/*---   (0x0E79)    Reserved   ---*/
/*---   (0x0E7A)    Reserved   ---*/
/*---   (0x0E7B)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0E7C)    LCDCR1;   
EXTERN TYPE_BYTE        __io(0x0E7D)    LCDCR2;   
EXTERN TYPE_BYTE        __io(0x0E7E)    LCDCR3;   
EXTERN TYPE_BYTE        __io(0x0E7F)    LCDCR4;   
EXTERN TYPE_BYTE        __io(0x0E80)    LCDCR5;   
EXTERN TYPE_BYTE        __io(0x0E81)    LCDCR6;   
EXTERN TYPE_BYTE        __io(0x0E82)    LCDCR7;   
/*---   (0x0E83)    Reserved   ---*/
/*---   (0x0E84)    Reserved   ---*/
/*---   (0x0E85)    Reserved   ---*/
/*---   (0x0E86)    Reserved   ---*/
/*---   (0x0E87)    Reserved   ---*/
/*---   (0x0E88)    Reserved   ---*/
/*---   (0x0E89)    Reserved   ---*/
/*---   (0x0E8A)    Reserved   ---*/
/*---   (0x0E8B)    Reserved   ---*/
/*---   (0x0E8C)    Reserved   ---*/
/*---   (0x0E8D)    Reserved   ---*/
/*---   (0x0E8E)    Reserved   ---*/
/*---   (0x0E8F)    Reserved   ---*/
/*---   (0x0E90)    Reserved   ---*/
/*---   (0x0E91)    Reserved   ---*/
/*---   (0x0E92)    Reserved   ---*/
/*---   (0x0E93)    Reserved   ---*/
/*---   (0x0E94)    Reserved   ---*/
/*---   (0x0E95)    Reserved   ---*/
/*---   (0x0E96)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0E97)    UATCNG;   
EXTERN TYPE_BYTE        __io(0x0E98)    EINTCR0;         /* External interrupt control register 0 */
EXTERN TYPE_BYTE        __io(0x0E99)    EINTCR5;         /* External interrupt control register 5 */
/*---   (0x0E98)    Reserved   ---*/
/*---   (0x0E99)    Reserved   ---*/
/*---   (0x0E9A)    Reserved   ---*/
/*---   (0x0E9B)    Reserved   ---*/
/*---   (0x0E9C)    Reserved   ---*/
/*---   (0x0E9D)    Reserved   ---*/
/*---   (0x0E9E)    Reserved   ---*/
/*---   (0x0E9F)    Reserved   ---*/
/*---   (0x0EA0)    Reserved   ---*/
/*---   (0x0EA1)    Reserved   ---*/
/*---   (0x0EA2)    Reserved   ---*/
/*---   (0x0EA3)    Reserved   ---*/
/*---   (0x0EA4)    Reserved   ---*/
/*---   (0x0EA5)    Reserved   ---*/
/*---   (0x0EA6)    Reserved   ---*/
/*---   (0x0EA7)    Reserved   ---*/
/*---   (0x0EA8)    Reserved   ---*/
/*---   (0x0EA9)    Reserved   ---*/
/*---   (0x0EAA)    Reserved   ---*/
/*---   (0x0EAB)    Reserved   ---*/
/*---   (0x0EAC)    Reserved   ---*/
/*---   (0x0EAD)    Reserved   ---*/
/*---   (0x0EAE)    Reserved   ---*/
/*---   (0x0EAF)    Reserved   ---*/
/*---   (0x0EB0)    Reserved   ---*/
/*---   (0x0EB1)    Reserved   ---*/
/*---   (0x0EB2)    Reserved   ---*/
/*---   (0x0EB3)    Reserved   ---*/
/*---   (0x0EB4)    Reserved   ---*/
/*---   (0x0EB5)    Reserved   ---*/
/*---   (0x0EB6)    Reserved   ---*/
/*---   (0x0EB7)    Reserved   ---*/
/*---   (0x0EB8)    Reserved   ---*/
/*---   (0x0EB9)    Reserved   ---*/
/*---   (0x0EBA)    Reserved   ---*/
/*---   (0x0EBB)    Reserved   ---*/
/*---   (0x0EBC)    Reserved   ---*/
/*---   (0x0EBD)    Reserved   ---*/
/*---   (0x0EBE)    Reserved   ---*/
/*---   (0x0EBF)    Reserved   ---*/
/*---   (0x0EC0)    Reserved   ---*/
/*---   (0x0EC1)    Reserved   ---*/
/*---   (0x0EC2)    Reserved   ---*/
/*---   (0x0EC3)    Reserved   ---*/
/*---   (0x0EC4)    Reserved   ---*/
/*---   (0x0EC5)    Reserved   ---*/
/*---   (0x0EC6)    Reserved   ---*/
/*---   (0x0EC7)    Reserved   ---*/
/*---   (0x0EC8)    Reserved   ---*/
/*---   (0x0EC9)    Reserved   ---*/
/*---   (0x0ECA)    Reserved   ---*/
/*---   (0x0ECB)    Reserved   ---*/
/*---   (0x0ECC)    Reserved   ---*/
/*---   (0x0ECD)    Reserved   ---*/
/*---   (0x0ECE)    Reserved   ---*/
/*---   (0x0ECF)    Reserved   ---*/
/*---   (0x0ED0)    Reserved   ---*/
/*---   (0x0ED1)    Reserved   ---*/
/*---   (0x0ED2)    Reserved   ---*/
/*---   (0x0ED3)    Reserved   ---*/
/*---   (0x0ED4)    Reserved   ---*/
/*---   (0x0ED5)    Reserved   ---*/
/*---   (0x0ED6)    Reserved   ---*/
/*---   (0x0ED7)    Reserved   ---*/
/*---   (0x0ED8)    Reserved   ---*/
/*---   (0x0ED9)    Reserved   ---*/
/*---   (0x0EDA)    Reserved   ---*/
/*---   (0x0EDB)    Reserved   ---*/
/*---   (0x0EDC)    Reserved   ---*/
/*---   (0x0EDD)    Reserved   ---*/
/*---   (0x0EDE)    Reserved   ---*/
/*---   (0x0EDF)    Reserved   ---*/
/*---   (0x0EE0)    Reserved   ---*/
/*---   (0x0EE1)    Reserved   ---*/
/*---   (0x0EE2)    Reserved   ---*/
/*---   (0x0EE3)    Reserved   ---*/
/*---   (0x0EE4)    Reserved   ---*/
/*---   (0x0EE5)    Reserved   ---*/
/*---   (0x0EE6)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0EE7)    ADCVRF;           
/*---   (0x0EE8)    Reserved   ---*/
/*---   (0x0EE9)    Reserved   ---*/
/*---   (0x0EEA)    Reserved   ---*/
/*---   (0x0EEB)    Reserved   ---*/
/*---   (0x0EEC)    Reserved   ---*/
EXTERN TYPE_BYTE_FSCTRL __io(0x0EED)    FSCTRL;  
/*---   (0x0EEE)    Reserved   ---*/
/*---   (0x0EEF)    Reserved   ---*/
/*---   (0x0EF0)    Reserved   ---*/
/*---   (0x0EF1)    Reserved   ---*/
/*---   (0x0EF2)    Reserved   ---*/
/*---   (0x0EF3)    Reserved   ---*/
/*---   (0x0EF4)    Reserved   ---*/
/*---   (0x0EF5)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0EF6)    MULCTR;  
/*---   (0x0EF7)    Reserved   ---*/
/*---   (0x0EF8)    Reserved   ---*/
/*---   (0x0EF9)    Reserved   ---*/
/*---   (0x0EFA)    Reserved   ---*/
/*---   (0x0EFB)    Reserved   ---*/
/*---   (0x0EFC)    Reserved   ---*/
/*---   (0x0EFD)    Reserved   ---*/
/*---   (0x0EFE)    Reserved   ---*/
/*---   (0x0EFF)    Reserved   ---*/

/***[SFR2]******************************************************/
EXTERN TYPE_BYTE        __io(0x0F00)    P0PD;            /* Port P0 input/output control */
EXTERN TYPE_BYTE        __io(0x0F01)    P1PD;            /* Port P1 input/output control */
EXTERN TYPE_BYTE        __io(0x0F02)    P2PD;            /* Port P2 input/output control */
/*---   (0x0F03)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F04)    P4PD;            /* Port P4 input/output control */
EXTERN TYPE_BYTE        __io(0x0F05)    P5PD;            /* Port P5 input/output control */
/*---   (0x0F06)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F07)    P7PD;            /* Port P7 input/output control */
EXTERN TYPE_BYTE        __io(0x0F08)    P8PD;            /* Port P8 input/output control */
EXTERN TYPE_BYTE        __io(0x0F09)    P9PD;            /* Port P9 input/output control */
/*---   (0x0F0A)    Reserved   ---*/
/*---   (0x0F0B)    Reserved   ---*/
/*---   (0x0F0C)    Reserved   ---*/
/*---   (0x0F0D)    Reserved   ---*/
/*---   (0x0F0E)    Reserved   ---*/
/*---   (0x0F0F)    Reserved   ---*/
/*---   (0x0F10)    Reserved   ---*/
/*---   (0x0F11)    Reserved   ---*/
/*---   (0x0F12)    Reserved   ---*/
/*---   (0x0F13)    Reserved   ---*/
/*---   (0x0F14)    Reserved   ---*/
/*---   (0x0F15)    Reserved   ---*/
/*---   (0x0F16)    Reserved   ---*/
/*---   (0x0F17)    Reserved   ---*/
/*---   (0x0F18)    Reserved   ---*/
/*---   (0x0F19)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F1A)    P0CR;            /* Port P0 input/output control */
EXTERN TYPE_BYTE        __io(0x0F1B)    P1CR;            /* Port P1 input/output control */
EXTERN TYPE_BYTE        __io(0x0F1C)    P2CR;            /* Port P2 input/output control */
/*---   (0x0F1D)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F1E)    P4CR;            /* Port P4 input/output control */
EXTERN TYPE_BYTE        __io(0x0F1F)    P5CR;            /* Port P5 input/output control */
/*---   (0x0F20)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F21)    P7CR;            /* Port P7 input/output control */
EXTERN TYPE_BYTE        __io(0x0F22)    P8CR;            /* Port P8 input/output control */
EXTERN TYPE_BYTE        __io(0x0F23)    P9CR;            /* Port P9 input/output control */
//EXTERN TYPE_BYTE        __io(0x0F25)    PBCR;            /* Port PB input/output control */
EXTERN TYPE_BYTE        __io(0x0F27)    P0PU;            /* Port P0 built-in pull-up resistor control */
EXTERN TYPE_BYTE        __io(0x0F28)    P1PU;            /* Port P1 built-in pull-up resistor control */
EXTERN TYPE_BYTE        __io(0x0F29)    P2PU;            /* Port P2 built-in pull-up resistor control */
/*---   (0x0F2A)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F2B)    P4PU;            /* Port P4 built-in pull-up resistor control */
EXTERN TYPE_BYTE        __io(0x0F2C)    P5PU;            /* Port P5 built-in pull-up resistor control */
/*---   (0x0F2D)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F2E)    P7PU;            /* Port P7 built-in pull-up resistor control */
EXTERN TYPE_BYTE        __io(0x0F2F)    P8PU;            /* Port P8 built-in pull-up resistor control */
EXTERN TYPE_BYTE        __io(0x0F30)    P9PU;            /* Port P9 built-in pull-up resistor control */
/*---   (0x0F31)    Reserved   ---*/
/*---   (0x0F32)    Reserved   ---*/
/*---   (0x0F33)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F34)    P0FC;            /* Port P0 function control */
/*---   (0x0F35)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F36)    P2FC;            /* Port P2 function control */
/*---   (0x0F37)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F38)    P4FC;            /* Port P4 function control */
EXTERN TYPE_BYTE        __io(0x0F39)    P5FC;            /* Port P5 function control */
/*---   (0x0F3A)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F3B)    P7FC;            /* Port P7 function control */
EXTERN TYPE_BYTE        __io(0x0F3C)    P8FC;            /* Port P8 function control */
EXTERN TYPE_BYTE        __io(0x0F3D)    P9FC;            /* Port P9 function control */
/*---   (0x0F3E)    Reserved   ---*/
//EXTERN TYPE_BYTE        __io(0x0F3F)    PBFC;            /* Port PB function control */
/*---   (0x0F40)    Reserved   ---*/
/*---   (0x0F41)    Reserved   ---*/
/*---   (0x0F42)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0F43)    P2OUTCR;         /* Port P2 output control */
/*---   (0x0F44)    Reserved   ---*/
/*---   (0x0F45)    Reserved   ---*/
/*---   (0x0F46)    Reserved   ---*/
/*---   (0x0F47)    Reserved   ---*/
/*---   (0x0F48)    Reserved   ---*/
/*---   (0x0F49)    Reserved   ---*/
//EXTERN TYPE_BYTE        __io(0x0F4A)    P9OUTCR;         /* Port P9 output control */
/*---   (0x0F4B)    Reserved   ---*/
//EXTERN TYPE_BYTE        __io(0x0F4C)    PBOUTCR;         /* Port PB output control */
/*---   (0x0F4D)    Reserved   ---*/
/*---   (0x0F4E)    Reserved   ---*/
/*---   (0x0F4F)    Reserved   ---*/
/*---   (0x0F50)    Reserved   ---*/
/*---   (0x0F51)    Reserved   ---*/
/*---   (0x0F52)    Reserved   ---*/
/*---   (0x0F53)    Reserved   ---*/
EXTERN TYPE_BYTE    __io(0x0F54)    UART1CR1;        /* UART1 control register 1 */
EXTERN TYPE_BYTE    __io(0x0F55)    UART1CR2;        /* UART1 control register 2 */
EXTERN TYPE_BYTE    __io(0x0F56)    UART1DR;         /* UART1 baud rate register */
EXTERN TYPE_BYTE    __io(0x0F57)    UART1SR;         /* UART1 status register */
EXTERN TYPE_BYTE    __io(0x0F58)    U1BF;
#define TD1BUF U1BF                                 
/* UART1 transmit data buffer */
#define RD1BUF U1BF                                 
/* UART1 receive data buffer */
/*---   (0x0F59)    Reserved   ---*/
//EXTERN TYPE_BYTE    __io(0x0F5A)    UART2CR1;        /* UART2 control register 1 */
//EXTERN TYPE_BYTE    __io(0x0F5B)    UART2CR2;        /* UART2 control register 2 */
//EXTERN TYPE_BYTE    __io(0x0F5C)    UART2DR;         /* UART2 baud rate register */
//EXTERN TYPE_BYTE    __io(0x0F5D)    UART2SR;         /* UART2 status register */
//EXTERN TYPE_BYTE    __io(0x0F5E)    U2BF;
//#define TD2BUF U2BF                                 
/* UART1 transmit data buffer */
//#define RD2BUF U2BF                                 
/* UART1 receive data buffer */
EXTERN TYPE_WORD_EX        __io(0x0F5A)    TA1DRA;
//#define TA0DRA _TA0DRA.word
#define TA1DRAL TA1DRA.TBYTE[0]                           
/* Timer counter A0 register AL */
#define TA1DRAH TA1DRA.TBYTE[1]                          
 /* Timer counter A0 register AH */
EXTERN TYPE_WORD_EX        __io(0x0F5C)    TA1DRB;
//#define TA0DRB _TA0DRB.word
#define TA1DRBL TA1DRB.TBYTE[0]
                           /* Timer counter A0 register BL */
#define TA1DRBH TA1DRB.TBYTE[1] 
                           /* Timer counter A0 register BH */

EXTERN TYPE_BYTE    __io(0x0F5E) TA1MOD	;
EXTERN TYPE_BYTE    __io(0x0F5F) TA1CR	;
EXTERN TYPE_BYTE    __io(0x0F60) TA1SR	;


/*---   (0x0F5F)    Reserved   ---*/
/*---   (0x0F60)    Reserved   ---*/
/*---   (0x0F61)    Reserved   ---*/
/*---   (0x0F62)    Reserved   ---*/
/*---   (0x0F63)    Reserved   ---*/
  /*---   (0x0F64)    Reserved   ---*/
/*---   (0x0F65)    Reserved   ---*/
/*---   (0x0F66)    Reserved   ---*/
/*---   (0x0F67)    Reserved   ---*/
/*---   (0x0F68)    Reserved   ---*/
/*---   (0x0F69)    Reserved   ---*/
/*---   (0x0F6A)    Reserved   ---*/
/*---   (0x0F6B)    Reserved   ---*/
/*---   (0x0F6C)    Reserved   ---*/
/*---   (0x0F6D)    Reserved   ---*/
/*---   (0x0F6E)    Reserved   ---*/
EXTERN TYPE_BYTE	__io(0x0F6F)    SIO0CR2;          /* Serial interface 0 control register2 */
EXTERN TYPE_BYTE	__io(0x0F70)    SIO1CR;          /* Serial interface 1 control register */
EXTERN TYPE_BYTE	__io(0x0F71)    SIO1SR;          /* Serial interface 1 status register */
EXTERN TYPE_BYTE	__io(0x0F72)    SIO1BUF;         /* Serial interface 1 buffer register */
EXTERN TYPE_BYTE	__io(0x0F73)    SIO1CR2;          /* Serial interface 1 control register2 */
EXTERN TYPE_BYTE	__io(0x0F74)    POFFCR0;         /* Low power consumption register 0 */
EXTERN TYPE_BYTE    __io(0x0F75)    POFFCR1;         /* Low power consumption register 1 */
EXTERN TYPE_BYTE    __io(0x0F76)    POFFCR2;         /* Low power consumption register 2 */
EXTERN TYPE_BYTE    __io(0x0F77)    POFFCR3;         /* Low power consumption register 3 */
/*---   (0x0F78)    Reserved   ---*/
/*---   (0x0F79)    Reserved   ---*/
/*---   (0x0F7A)    Reserved   ---*/
/*---   (0x0F7B)    Reserved   ---*/
/*---   (0x0F7C)    Reserved   ---*/
/*---   (0x0F7D)    Reserved   ---*/
/*---   (0x0F7E)    Reserved   ---*/
/*---   (0x0F7F)    Reserved   ---*/
/*---   (0x0F80)    Reserved   ---*/
/*---   (0x0F81)    Reserved   ---*/
/*---   (0x0F82)    Reserved   ---*/
/*---   (0x0F83)    Reserved   ---*/
/*---   (0x0F84)    Reserved   ---*/
/*---   (0x0F85)    Reserved   ---*/
/*---   (0x0F86)    Reserved   ---*/
/*---   (0x0F87)    Reserved   ---*/
EXTERN TYPE_BYTE    __io(0x0F88)    TC0CR1	;
EXTERN TYPE_BYTE    __io(0x0F89)    TC0CR2	;
EXTERN TYPE_BYTE    __io(0x0F8a)    TC0CR3	;
EXTERN TYPE_BYTE    __io(0x0F8b)    TC0DRAL	;
EXTERN TYPE_BYTE    __io(0x0F8C)    TC0DRAH	;
EXTERN TYPE_BYTE    __io(0x0F8D)    TC0DRBL	;
EXTERN TYPE_BYTE    __io(0x0F8E)    TC0DRBH	;
EXTERN TYPE_BYTE    __io(0x0F8F)    TC0DRCL	;
EXTERN TYPE_BYTE    __io(0x0F90)    TC0DRCH	;
EXTERN TYPE_BYTE    __io(0x0F91)    TC0DRDL	;
EXTERN TYPE_BYTE    __io(0x0F92)    TC0DRDH	;
EXTERN TYPE_BYTE    __io(0x0F93)    TC0DREL	;
EXTERN TYPE_BYTE    __io(0x0F94)    TC0DREH	;
EXTERN TYPE_BYTE    __io(0x0F95)    TC0CAPAL;
EXTERN TYPE_BYTE    __io(0x0F96)    TC0CAPAH;
EXTERN TYPE_BYTE    __io(0x0F97)    TC0CAPBL;
EXTERN TYPE_BYTE    __io(0x0F98)   TC0CAPBH	;

EXTERN TYPE_BYTE    __io(0x0F9C)    TC1CR1	;
EXTERN TYPE_BYTE    __io(0x0F9D)    TC1CR2	;
EXTERN TYPE_BYTE    __io(0x0F9E)    TC1CR3	;
EXTERN TYPE_BYTE    __io(0x0F9F)    TC1DRAL	;
EXTERN TYPE_BYTE    __io(0x0FA0)    TC1DRAH	;
EXTERN TYPE_BYTE    __io(0x0FA1)    TC1DRBL	;
EXTERN TYPE_BYTE    __io(0x0FA2)    TC1DRBH	;
EXTERN TYPE_BYTE    __io(0x0FA3)    TC1DRCL	;
EXTERN TYPE_BYTE    __io(0x0FA4)    TC1DRCH	;
EXTERN TYPE_BYTE    __io(0x0FA5)    TC1DRDL	;
EXTERN TYPE_BYTE    __io(0x0FA6)    TC1DRDH	;
EXTERN TYPE_BYTE    __io(0x0FA7)    TC1DREL	;
EXTERN TYPE_BYTE    __io(0x0FA8)    TC1DREH	;
EXTERN TYPE_BYTE    __io(0x0FA9)    TC1CAPAL;
EXTERN TYPE_BYTE    __io(0x0FAA)    TC1CAPAH;
EXTERN TYPE_BYTE    __io(0x0FAB)    TC1CAPBL;
EXTERN TYPE_BYTE    __io(0x0FAC)    TC1CAPBH;

EXTERN TYPE_BYTE    __io(0x0FB0)    TC2CR1	;
EXTERN TYPE_BYTE    __io(0x0FB1)    TC2CR2	;
EXTERN TYPE_BYTE    __io(0x0FB2)    TC2CR3	;
EXTERN TYPE_BYTE    __io(0x0FB3)    TC2DRAL	;
EXTERN TYPE_BYTE    __io(0x0FB4)    TC2DRAH	;
EXTERN TYPE_BYTE    __io(0x0FB5)    TC2DRBL	;
EXTERN TYPE_BYTE    __io(0x0FB6)    TC2DRBH	;
EXTERN TYPE_BYTE    __io(0x0FB7)    TC2DRCL	;
EXTERN TYPE_BYTE    __io(0x0FB8)    TC2DRCH	;
EXTERN TYPE_BYTE    __io(0x0FB9)    TC2DRDL	;
EXTERN TYPE_BYTE    __io(0x0FBA)    TC2DRDH	;
EXTERN TYPE_BYTE    __io(0x0FBB)    TC2DREL	;
EXTERN TYPE_BYTE    __io(0x0FBC)    TC2DREH	;
EXTERN TYPE_BYTE    __io(0x0FBD)    TC2CAPAL;
EXTERN TYPE_BYTE    __io(0x0FBE)    TC2CAPAH;
EXTERN TYPE_BYTE    __io(0x0FBF)    TC2CAPBL;
EXTERN TYPE_BYTE    __io(0x0FC0)    TC2CAPBH;
/*---   (0x0FC2)    Reserved   ---*/
/*---   (0x0FC3)    Reserved   ---*/
EXTERN TYPE_BYTE        __io(0x0FC4)    KWUCR0;          /* Key-on wakeup control register 0 */
EXTERN TYPE_BYTE        __io(0x0FC5)    KWUCR1;          /* Key-on wakeup control register 1 */
EXTERN TYPE_BYTE        __io(0x0FC6)    VDCR1;           /* Voltage detection control register 1 */
EXTERN TYPE_BYTE        __io(0x0FC7)    VDCR2;           /* Voltage detection control register 2 */
EXTERN TYPE_BYTE        __io(0x0FC8)    RTCCR;           /* Real time clock control register */
/*---   (0x0FC9)    Reserved   ---*/
EXTERN TYPE_BYTE    __io(0x0FCA)	KWUCR2;			/* Key-on wakeup control register 2 */
EXTERN TYPE_BYTE    __io(0x0FCB)	KWUCR3;			/* Key-on wakeup control register 3 */
EXTERN TYPE_BYTE    __io(0x0FCC)    IRSTSR;          
EXTERN TYPE_BYTE    __io(0x0FCD)    WUCCR;           /* Warm-up counter control register */
EXTERN TYPE_BYTE    __io(0x0FCE)    WUCDR;           /* Warm-up counter data register */
EXTERN TYPE_BYTE    __io(0x0FCF)    CGCR;            /* Clock gear control register */
EXTERN TYPE_BYTE    __io(0x0FD0)    FLSCR1;          /* Flash memory control register 1 */
EXTERN TYPE_BYTE    __io(0x0FD1)    FLCM;
#define FLSCR2 FLCM                                
 /* Flash memory control register 2 */
#define FLSCRM FLCM                                 
/* Flash memory control register 1 monitor */
EXTERN TYPE_BYTE    __io(0x0FD2)    FLSSTB;          /* Flash memory standby control register */
EXTERN TYPE_BYTE    __io(0x0FD3)    SPCR;            /* Port input control register */
EXTERN TYPE_BYTE    __io(0x0FD4)    WDCTR;           /* Watchdog timer control register */
EXTERN TYPE_BYTE    __io(0x0FD5)    WDCDR;           /* Watchdog timer control code register */
EXTERN TYPE_BYTE    __io(0x0FD6)    WDCNT;           /* 8-bit up counter monitor */
EXTERN TYPE_BYTE    __io(0x0FD7)    WDST;            /* Watchdog timer status */
EXTERN TYPE_BYTE        __io(0x0FD8)    EINTCR1;         /* External interrupt control register 1 */
EXTERN TYPE_BYTE        __io(0x0FD9)    EINTCR2;         /* External interrupt control register 2 */
EXTERN TYPE_BYTE        __io(0x0FDA)    EINTCR3;         /* External interrupt control register 3 */
EXTERN TYPE_BYTE        __io(0x0FDB)    EINTCR4;         /* External interrupt control register 4 */
EXTERN TYPE_BYTE        __io(0x0FDC)    SYSCR1;          /* System control register 1 */
EXTERN TYPE_BYTE        __io(0x0FDD)    SYSCR2;          /* System control register 2 */
EXTERN TYPE_BYTE        __io(0x0FDE)    SYSCR3;          /* System control register 3 */
EXTERN TYPE_BYTE        __io(0x0FDF)    SYS4;
	#define SYSCR4 SYS4
	#define SYSSR4 SYS4
EXTERN TYPE_BYTE    __io(0x0FE0)    ILL;             /* Interrupt latch (ILL) */
EXTERN TYPE_BYTE    __io(0x0FE1)    ILH;             /* Interrupt latch (ILH) */
EXTERN TYPE_BYTE    __io(0x0FE2)    ILE;             /* Interrupt latch (ILE) */
EXTERN TYPE_BYTE    __io(0x0FE3)    ILD;             /* Interrupt latch (ILD) */
/*---   (0x0FE4)    Reserved   ---*/
/*---   (0x0FE5)    Reserved   ---*/
/*---   (0x0FE6)    Reserved   ---*/
/*---   (0x0FE7)    Reserved   ---*/
/*---   (0x0FE8)    Reserved   ---*/
/*---   (0x0FE9)    Reserved   ---*/
/*---   (0x0FEA)    Reserved   ---*/
/*---   (0x0FEB)    Reserved   ---*/
/*---   (0x0FEC)    Reserved   ---*/
/*---   (0x0FED)    Reserved   ---*/
/*---   (0x0FEE)    Reserved   ---*/
/*---   (0x0FEF)    Reserved   ---*/
//EXTERN TYPE_BYTE        __io(0x0FF0)    ILRSL;          /*  */
//EXTERN TYPE_BYTE        __io(0x0FF1)    ILRSH;          /*  */
//EXTERN TYPE_BYTE        __io(0x0FF2)    ILRSE;          /*  */
//EXTERN TYPE_BYTE        __io(0x0FF3)    ILRSD;          /*  */
//EXTERN TYPE_BYTE        __io(0x0FF4)    ILPRS5;          /*  */
//EXTERN TYPE_BYTE        __io(0x0FF5)    ILPRS6;          /*  */
//EXTERN TYPE_BYTE        __io(0x0FF6)    ILPRS7;          /*  */
/*---   (0x0FF6)    Reserved   ---*/
/*---   (0x0FF7)    Reserved   ---*/
/*---   (0x0FF8)    Reserved   ---*/
/*---   (0x0FF9)    Reserved   ---*/
/*---   (0x0FFA)    Reserved   ---*/
/*---   (0x0FFB)    Reserved   ---*/
/*---   (0x0FFC)    Reserved   ---*/
/*---   (0x0FFD)    Reserved   ---*/
/*---   (0x0FFE)    Reserved   ---*/
/*---   (0x0FFF)    Reserved   ---*/

/*-eof-*/

//===========================

	
//===========================